% Nuestra LU pura (con pivotaje).
A = [1,2,1; 3,4,5; 5,8,1];
A = [1,2,1,-1; 2,2,-4,0; 1,4,1,3; 1,2,0,5] 

n = size(A,1);

U = A;
L = eye(n);
P = eye(n);

for k = 1:n-1
    [m,j] = max( abs(U(k:n,k)) );
    if j~=1
        r = j+k-1;
        U([k,r],k:n) = U([r,k],k:n);
        L([k,r],1:k-1) = L([r,k],1:k-1);
        P([k,r],:) = P([r,k],:);
    end
    disp('U1 =')
    disp(U)
    
    v = k:n;

    for ii = k+1:n
        L(ii, k) = U(ii,k)/U(k,k);
        U(ii,v) = U(ii,v) - L(ii,k)*U(k,v);
    end

    disp('U2 =')
    disp(U)
end

